SSL_CTX_SET_READ_AHEAD(3)

NAME
SSL_CTX_set_read_ahead, SSL_CTX_get_read_ahead, SSL_set_read_ahead, SSL_get_read_ahead, SSL_CTX_get_default_read_ahead - manage whether to read as many input bytes as possible

SYNOPSIS
#include <openssl/ssl.h>
void
SSL_CTX_set_read_ahead(SSL_CTX *ctx, int yes);
long
SSL_CTX_get_read_ahead(SSL_CTX *ctx);
void
SSL_set_read_ahead(SSL *s, int yes);
long
SSL_get_read_ahead(const SSL *s);
long
SSL_CTX_get_default_read_ahead(SSL_CTX *ctx);

DESCRIPTION
SSL_CTX_set_read_ahead() and SSL_set_read_ahead() set whether as many input bytes as possible are read for non-blocking reads. For example if x bytes are currently required by OpenSSL, but y bytes are available from the underlying BIO (where y > x), then OpenSSL will read all y bytes into its buffer (provided that the buffer is large enough) if reading ahead is on, or x bytes otherwise. The parameter yes should be 0 to ensure reading ahead is off, or non zero otherwise.

SSL_CTX_get_read_ahead() and SSL_get_read_ahead() indicate whether reading ahead is set or not.

SSL_CTX_get_default_read_ahead() is identical to SSL_CTX_get_read_ahead().

These functions are implemented as macros.

These functions have no effect when used with DTLS.

RETURN VALUES
SSL_CTX_get_read_ahead() and SSL_get_read_ahead() return 0 if reading ahead is off or non-zero otherwise, except that the return values are undefined for DTLS.

SEE ALSO
ssl(3), SSL_pending(3)

HISTORY
SSL_set_read_ahead() and SSL_get_read_ahead() appeared in SSLeay 0.4 or earlier and have been available since OpenBSD 2.4.

SSL_CTX_set_read_ahead(), SSL_CTX_get_read_ahead(), and SSL_CTX_get_default_read_ahead() first appeared in OpenSSL 0.9.2b and have been available since OpenBSD 2.6.

CAVEATS
Switching read ahead on can impact the behaviour of the SSL_pending(3) function.